// Code generated by genpjrpc. DO NOT EDIT.
//  genpjrpc version: v0.1.0

package rpcclient

import (
	"context"
	"fmt"

	"github.com/google/uuid"
	"gitlab.com/pjrpc/pjrpc/v2/client"

	"middlewares/service"
)

// List of the client JSON-RPC methods.
const (
	JSONRPCMethodMethod_Client    = "method"
	JSONRPCMethodExclusive_Client = "exclusive"
)

// ServiceClient is an API client for Service service.
type ServiceClient interface {
	Method(ctx context.Context, in *service.In, mods ...client.Mod) (service.Out, error)
	Exclusive(ctx context.Context, in *service.In, mods ...client.Mod) (service.Out, error)
}

type implServiceClient struct {
	cl client.Invoker
}

// NewServiceClient returns new client implementation of the Service service.
func NewServiceClient(cl client.Invoker) ServiceClient {
	return &implServiceClient{cl: cl}
}

func (c *implServiceClient) Method(ctx context.Context, in *service.In, mods ...client.Mod) (result service.Out, err error) {
	gen, err := uuid.NewUUID()
	if err != nil {
		return result, fmt.Errorf("failed to create uuid generator: %w", err)
	}

	err = c.cl.Invoke(ctx, gen.String(), JSONRPCMethodMethod_Client, in, &result, mods...)
	if err != nil {
		return result, fmt.Errorf("failed to Invoke method %q: %w", JSONRPCMethodMethod_Client, err)
	}

	return result, nil
}

func (c *implServiceClient) Exclusive(ctx context.Context, in *service.In, mods ...client.Mod) (result service.Out, err error) {
	gen, err := uuid.NewUUID()
	if err != nil {
		return result, fmt.Errorf("failed to create uuid generator: %w", err)
	}

	err = c.cl.Invoke(ctx, gen.String(), JSONRPCMethodExclusive_Client, in, &result, mods...)
	if err != nil {
		return result, fmt.Errorf("failed to Invoke method %q: %w", JSONRPCMethodExclusive_Client, err)
	}

	return result, nil
}
